package com.sambath.kunkhmer.adapter

import android.graphics.drawable.Drawable
import android.util.Patterns
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.sambath.kunkhmer.R
import com.sambath.kunkhmer.remote.Matches
import com.squareup.picasso.Picasso


class FighterAdapter (private val cardList: List<Matches>) : RecyclerView.Adapter<FighterAdapter.ViewHolder>()  {
    class CardViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView)

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): FighterAdapter.ViewHolder {
        val itemView = LayoutInflater.from(parent.context).inflate(R.layout.layout_fighter_card, parent, false)
        return FighterAdapter.ViewHolder(itemView)
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val currentItem = cardList[position]

        val imageUrl = currentItem.fighters[0].filename
        if (Patterns.WEB_URL.matcher(imageUrl).matches()) {
            // Load image from URL
            Picasso.get()
                .load(currentItem.fighters[0].filename)
                .into(holder.imageLeft);
        } else {
            // Load default image
            Picasso.get()
                .load(R.drawable.ic_user_white)
                .into(holder.imageLeft)
        }

        holder.imageLeftTitle.text = currentItem.fighters[0]?.name
        if (Patterns.WEB_URL.matcher(imageUrl).matches()) {
            // Load image from URL
            Picasso.get()
                .load(currentItem.fighters[0].filename)
                .into(holder.imageRight);
        } else {
            // Load default image
            Picasso.get()
                .load(R.drawable.ic_user_white)
                .into(holder.imageRight)
        }
        holder.imageRightTitle.text = currentItem.fighters[1]?.name
        holder.date.text = currentItem.matchInfo.date
        holder.title.text = currentItem.matchInfo.title

//        if(currentItem.favorite) {
//            val drawable: Drawable? = holder.itemView.context.getDrawable(R.drawable.ic_star_filled_50)
//            holder.favorite.setImageDrawable(drawable)
//        } else {
//            val drawable: Drawable? = holder.itemView.context.getDrawable(R.drawable.ic_star_50)
//            holder.favorite.setImageDrawable(drawable)
//        }

//        holder.favorite.setOnClickListener{
//            if (!currentItem.favorite) {
//                // Perform bookmarking action
//                val drawable: Drawable? = holder.itemView.context.getDrawable(R.drawable.ic_star_filled_50)
//                holder.favorite.setImageDrawable(drawable)
//                currentItem.favorite = true
//            } else {
//                // Perform unbookmarking action
//                val drawable: Drawable? = holder.itemView.context.getDrawable(R.drawable.ic_star_50)
//                holder.favorite.setImageDrawable(drawable)
//                currentItem.favorite = false
//            }
//        }

    }

    override fun getItemCount() = cardList.size

    // Holds the views for adding it to image and text
    class ViewHolder(ItemView: View) : RecyclerView.ViewHolder(ItemView) {
        val imageLeft: ImageView = itemView.findViewById(R.id.imageLeft)
        val imageLeftTitle: TextView = itemView.findViewById(R.id.titleLeft)
        val imageRight: ImageView = itemView.findViewById(R.id.imageRight)
        val imageRightTitle: TextView = itemView.findViewById(R.id.titleRight)
        val date: TextView = itemView.findViewById(R.id.tvDate)
        val title: TextView = itemView.findViewById(R.id.titleMatch)
        val favorite: ImageView = itemView.findViewById(R.id.bookmarkToggleButton)
    }
}